# FAQ & Resources

## Ecosystem Tools FAQ

<details>

<summary>Please provide links to officially recognized wallets.</summary>

[Keplr](https://www.keplr.app/chains/dydx), [Leap](https://www.leapwallet.io/chain/dydx) are popular Cosmos wallets.

</details>

<details>

<summary>Are there any multi-sig and/or MPCs that support the dYdX chain?</summary>

Yes, there are a few options [Keplr Multisig](https://multisig.keplr.app/), [Fordefi](https://blog.fordefi.com/fordefi-mpc-wallet-launches-native-dydx-support)

</details>

<details>

<summary>Please provide a transaction to exchange the USDC from the Noble chain to the USDC of the Ethereum chain for reference?</summary>

From Noble - <https://www.mintscan.io/noble/tx/51C848560634B18E4D0F69D9D9064E78C1FB4CD1BF6DB75098360FFB7D656DAD?height=4428705*>

On Ethereum - <https://etherscan.io/tx/0x03d2614f3b3d866ce5d8eef1d7e1b2f525af67c616c7f6531e1c32877b930a8c*>

</details>

## Front End FAQ

<details>

<summary>Is there a way to get user's BuyingPower from API? Or from SDK?</summary>

You can get equity and freeCollateral from the /v4/addresses/\<address> endpoint

[\*](https://docs.dydx.trade/developers/indexer/indexer_api#getaddress)<https://docs.dydx.trade/developers/indexer/indexer_api#getaddress*>

it won't make sense to get BuyingPower from API since each market has different maximum leverage

</details>

<details>

<summary>I cant find a GoodTilBlock param in the placeOrder function</summary>

<https://github.com/dydxprotocol/v4-clients/blob/main/v4-client-js/examples/short_term_order_composite_example.ts>

</details>

<details>

<summary>Sometimes I get "FillOrKill order could not be fully filled" error after I place a market order in ETH-USD market on a testnet, but in fact I'm sending the timeInForce: "GTT" (and provide "goodTilTimeInSeconds"), not "FOK", do you have any hints what am I doing wrong? I'm using placeOrder function from your js sdk</summary>

* Market orders need to be short-term order (with GoodTilBlock set). Please take a look at the file [v4dydxcli.py](http://v4dydxcli.py/) here <https://github.com/chiwalfrm/dydxexamples/tree/main/dydxcli>

</details>

<details>

<summary>Do you have an example on how to hexidecimal -> accAddress.</summary>

[\*](https://twitter.com/LawrenceChiu14/status/1716491077673275876)<https://twitter.com/LawrenceChiu14/status/1716491077673275876*>

*You still need to own the metamask address (have the private key) to run the derivation to determine dydxaddress*

*If you don't own the metamask address, it's not possible to derive*

*Essentially : metamask address —> sign a message —> dydx address*

*If you can't sign the message, then you can't get the dydx address*

</details>

<details>

<summary>I want to create an alternative UI for dydx and user will sign a message with metamask to login</summary>

The user can connect their metamask wallet to your alternative UI. Then you just ask the user to sign the message like in my example. The frontend code is open-source, it can be used for reference <https://github.com/dydxprotocol/v4-web>

</details>

## Websocket FAQ

<details>

<summary>In the Indexer Websocket service, do we need to maintain a heartbeat stream to keep connected?</summary>

* It doesn't need a heartbeat. We have a V4 orderbook example at <https://github.com/chiwalfrm/dydxexamples/tree/main/v4orderbook>

</details>

<details>

<summary>Is it possible to subscribe to a new block event via ws?</summary>

* That's not available on websocket, however, it is available via REST *<https://v4-> teacher.vercel.app/integration\_docs/indexer\_api#getheightor* \
  \
  If you run a full node that can keep up with the chain, you would always know the block height (second way is recommended so you don't hit the rate limit on the REST endpoint)

</details>

<details>

<summary>How can we know the block number of an orderbook snapshot we get on websocket or on indexer rest api request?</summary>

<https://docs.dydx.trade/developers/indexer/indexer_api#getheight>

</details>

<details>

<summary>Can we assume one orderbook update will be published per block? Per Pair</summary>

* No because the order book is off chain

</details>

<details>

<summary>Is it possible to subscribe to trade confirmation events via ws?</summary>

* You can get fills via ws, v4\_subaccount channel

</details>

<details>

<summary>We want to inspect order info from GET /orders/{orderId}, How do I get this orderID without using GET /orders, because there may be too many orders in the queue. Could i get orderID through clientID or txs_hash?</summary>

* If you run a websocket client, you could just monitor the v4\_subaccounts feedthat'll have orders so you can see the orderId and match that up with the clientId

</details>


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.dydx.community/dydx-chain-technical-docs/front-end-and-wallets/faq-and-resources.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
